' Copyright 2008 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices

''' <summary>
''' Class for activating and deactivating bluetooth radio.
''' </summary>
Public Class Bluetooth
    'http://msdn.microsoft.com/en-us/library/aa916277.aspx
    <DllImport("Bthutil.dll", SetLastError:=True, CallingConvention:=CallingConvention.Winapi)> _
    Private Shared Function BthGetMode(ByRef pdwMode As Integer) As Integer
    End Function
    <DllImport("Bthutil.dll", SetLastError:=True, CallingConvention:=CallingConvention.Winapi)> _
    Private Shared Function BthSetMode(ByVal pdwMode As Integer) As Integer
    End Function

    ''' <summary>
    ''' Gets a value indicating whether bluetooth radio is activated.
    ''' </summary>
    ''' <value>
    ''' <c>true</c> if this instance is activated; otherwise, <c>false</c>.
    ''' </value>
    Public Shared ReadOnly Property IsActivated() As Boolean
        Get
            Dim pdwMode As Integer = -1
            BthGetMode(pdwMode)
            Return (pdwMode > 0)
        End Get
    End Property
    ''' <summary>
    ''' Activates bluetooth radio.
    ''' </summary>
    Public Shared Sub Activate()
        If BthSetMode(1) <> 0 Then
            MsgBox("Unable to activate bluetooth.", MsgBoxStyle.Exclamation)
        End If
    End Sub
    ''' <summary>
    ''' Deaktivates bluetooth radio.
    ''' </summary>
    Public Shared Sub Deactivate()
        If BthSetMode(0) <> 0 Then
            MsgBox("Unable to deactivate bluetooth.", MsgBoxStyle.Exclamation)
        End If
    End Sub
End Class
