' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Module Module1
    ''' <summary>
    ''' Calculates and returns the best size of the given font for a specific rect.
    ''' </summary>
    ''' <param name="text">The text.</param>
    ''' <param name="font">The font.</param>
    ''' <param name="style">The style.</param>
    ''' <param name="width">The width.</param>
    ''' <param name="height">The height.</param>
    ''' <returns></returns>
    Public Function getBestFontSize(ByRef text As String, ByVal font As String, ByVal style As FontStyle, ByVal width As Integer, ByVal height As Integer) As Single
        Dim pe As Graphics = Graphics.FromImage(New Bitmap(1, 1))
        Dim size As Single = 1
        Dim fnt As New Font(font, size, style)
        Dim measureSize As Size = pe.MeasureString(text, fnt).ToSize
        Do
            size += CSng(0.5)
            fnt = New Font(font, size, style)
            measureSize = pe.MeasureString(text, fnt).ToSize
        Loop While size < 40 And measureSize.Width <= width And measureSize.Height <= height
        Return size
    End Function
    Public Function Encode(ByVal plainText As String) As String
        Encode = Replace(plainText, "&", "&amp;")
        Encode = Replace(Encode, "<", "&lt;")
        Encode = Replace(Encode, ">", "&gt;")
        Encode = Replace(Encode, """", "&quot;")
        Encode = Replace(Encode, "'", "&apos;")
    End Function
    Public Function PositiveMod(ByVal a As Integer, ByVal m As Integer) As Integer
        PositiveMod = a Mod m
        If PositiveMod < 0 Then
            PositiveMod += m
        End If
    End Function
    Public Function IsWindowsMobile5OrHigher() As Boolean
        Return Environment.OSVersion.Platform = PlatformID.WinCE AndAlso (Environment.OSVersion.Version.Major >= 6 OrElse (Environment.OSVersion.Version.Major = 5 AndAlso Environment.OSVersion.Version.Minor >= 1))
    End Function
End Module
