' Copyright 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports Microsoft.WindowsMobile.Status

Public Class PhoneState
    Private WithEvents gprsState As SystemState
    Private WithEvents roamingState As SystemState
    Public Event DataStateChanged()
    Public Sub New()
        Try
            gprsState = New SystemState(SystemProperty.PhoneGprsCoverage)
        Catch e As Exception
        End Try
        Try
            roamingState = New SystemState(SystemProperty.PhoneRoaming)
        Catch e As Exception
        End Try
    End Sub
    Public ReadOnly Property IsRoaming() As Boolean
        Get
            Try
                Return SystemState.PhoneRoaming
            Catch e As Exception
                ' be safe and say we are roaming
                Return True
            End Try
        End Get
    End Property
    Public ReadOnly Property HasGPRSCoverage() As Boolean
        Get
            Try
                Return SystemState.PhoneGprsCoverage
            Catch e As Exception
                Return False
            End Try
        End Get
    End Property
    Private Sub dataStatus_Changed(ByVal sender As Object, ByVal args As ChangeEventArgs) Handles gprsState.Changed, roamingState.Changed
        RaiseEvent DataStateChanged()
    End Sub
End Class

