' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Public Class frmSplashScreen
    Private logoImage As Bitmap = Nothing
    Private imageAttr As System.Drawing.Imaging.ImageAttributes = New System.Drawing.Imaging.ImageAttributes()
    Private destRect As Rectangle
    Private fnt As Font = Nothing
    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        If fnt Is Nothing Then
            If Me.Size.Width <= 240 OrElse Me.Size.Height <= 350 Then
                fnt = New Font("Arial", getBestFontSize(getAppVersion(), "Arial", FontStyle.Regular, 80, 10), FontStyle.Regular)
            Else
                fnt = New Font("Arial", getBestFontSize(getAppVersion(), "Arial", FontStyle.Regular, 160, 20), FontStyle.Regular)
            End If
        End If

        If logoImage Is Nothing Then
            If Me.Size.Width <= 240 OrElse Me.Size.Height <= 350 Then
                logoImage = New Bitmap(GetResourceStream("osmtracker.png"))
            Else
                logoImage = New Bitmap(GetResourceStream("osmtrackervga.png"))
            End If
            ' Set transparent key
            Dim bgimgcolor As Color = logoImage.GetPixel(0, 0)
            imageAttr.SetColorKey(bgimgcolor, bgimgcolor)
            destRect = New Rectangle((Me.Width - logoImage.Width) >> 1, (Me.Height - logoImage.Height) >> 1, logoImage.Width, logoImage.Height)
        End If
        pe.Graphics.DrawImage(logoImage, destRect, 0, 0, logoImage.Width, logoImage.Height, GraphicsUnit.Pixel, imageAttr)
        Dim size As Size = pe.Graphics.MeasureString(getAppVersion(), fnt).ToSize

        If Me.Size.Width <= 240 OrElse Me.Size.Height <= 350 Then
            pe.Graphics.DrawString(getAppVersion(), fnt, New SolidBrush(Color.Black), (Me.Width - size.Width + 3) >> 1, destRect.Y + logoImage.Height - size.Height - 5)
        Else
            pe.Graphics.DrawString(getAppVersion(), fnt, New SolidBrush(Color.Black), (Me.Width - size.Width + 6) >> 1, destRect.Y + logoImage.Height - size.Height - 10)
        End If
    End Sub
    Protected Overrides Sub OnPaintBackground(ByVal pe As System.Windows.Forms.PaintEventArgs)
        ' needs to be empty, otherwise you see a white non transparent background
    End Sub
    Public Sub New()
        InitializeComponent()

        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.FixedDialog
    End Sub
End Class
