' Copyright 2007 Rubke <interrubke@gmail.com>
' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Imports System.IO

Public Class frmPOITableView
    Private Sub mnuPOIdelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPOIdelete.Click
        If PoiListView.SelectedIndices.Count > 0 AndAlso MsgBox("Delete waypoint(s), Are you sure?", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
            Dim index As Integer
            For Each index In PoiListView.SelectedIndices
                Form1.logic.DeleteWaypoint(PoiListView.Items.Count - index - 1, Form1.logic.DataFolder & IO.Path.DirectorySeparatorChar & PoiListView.Items(index).SubItems(5).Text)
            Next
            FillPosListView()
        End If
    End Sub
    Private Sub mnuPOIplayAudio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPOIplayAudio.Click
        PlayListAudio()
    End Sub
    Private Sub PoiListView_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles PoiListView.KeyPress
        PlayListAudio()
    End Sub
    Private Sub PoiListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PoiListView.SelectedIndexChanged
        Dim strUrl As String
        Select Case PoiListView.SelectedIndices.Count
            Case 1 ' only one entry selected
                strUrl = PoiListView.Items(PoiListView.SelectedIndices.Item(0)).SubItems(5).Text
                mnuPOIdelete.Enabled = True
                mnuPOIplayAudio.Enabled = (strUrl.Length > 0) And strUrl.EndsWith(".wav")
            Case Else
                mnuPOIplayAudio.Enabled = False
                mnuPOIdelete.Enabled = False
        End Select
    End Sub
    Private Sub PlayListAudio()
        If PoiListView.SelectedIndices.Count = 1 Then
            Dim strUrl As String
            strUrl = PoiListView.Items(PoiListView.SelectedIndices.Item(0)).SubItems(5).Text
            If strUrl.Length > 0 And strUrl.EndsWith(".wav") Then
                Dim index As Integer = PoiListView.SelectedIndices.Item(0)
                Dim strFile As String = PoiListView.Items(index).SubItems(5).Text
                Dim strFileName As String = Form1.logic.DataFolder & IO.Path.DirectorySeparatorChar & strFile
                Application.DoEvents()
                Form1.logic.TSoundPlayer.PlayClip(strFileName)
            End If
        End If
    End Sub
    Public Sub FillPosListView()

        Dim oWpt As GPXFile.OSMWayPoint
        Dim oitem As ListViewItem
        Dim i As Long = 1

        With PoiListView
            .SuspendLayout()
            .Items.Clear()
            For Each oWpt In Form1.logic.WayPoints
                oitem = New ListViewItem
                oitem.Text = i.ToString
                oitem.SubItems.Add(oWpt.Name) ' name
                oitem.SubItems.Add(oWpt.GetLatitudeString) ' lat
                oitem.SubItems.Add(oWpt.GetLongitudeString) ' lon
                oitem.SubItems.Add(oWpt.Time)
                oitem.SubItems.Add(oWpt.LinkHref)
                .Items.Insert(0, oitem)
                i += 1
            Next
            .ResumeLayout()
            .Refresh()
        End With
    End Sub
End Class
