' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.IO
Imports System.Reflection

Public Class Form1
    Private tileManager As New TileManager
    Public Shared myCultureInfo As New System.Globalization.CultureInfo("en-US")
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each s As String In tileManager.TileProviderList
            tileProvider.Items.Add(s)
        Next

        If tileProvider.Items.Count = 0 Then
            MsgBox("No tile providers with a storage directory defined. Exiting now.", MsgBoxStyle.Information)
            Application.Exit()
            Exit Sub
        End If

        For i As Integer = 1 To 250
            zoom.Items.Add(i)
        Next

        zoom.Text = tileManager.Zoom.ToString
        txtLat.Text = tileManager.Latitude.ToString
        txtLon.Text = tileManager.Longitude.ToString

        tileProvider.SelectedIndex = 0
        DatePicker.MaxDate = Now.AddDays(-1)
        DatePicker.Value = Now.AddDays(-14)
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        tileManager.DeleteOldTiles(DatePicker.Value)
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        tileManager.UpdateOldTiles(DatePicker.Value)
    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        tileManager.GetTileInfos(DatePicker.Value)
    End Sub
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Try
            tileManager.Latitude = Double.Parse(Replace(txtLat.Text, ",", "."), myCultureInfo)
            tileManager.Longitude = Double.Parse(Replace(txtLon.Text, ",", "."), myCultureInfo)
            tileManager.Zoom = CInt(zoom.Text)
        Catch ex As Exception
            MsgBox("Error: " & ex.Message, MsgBoxStyle.Critical)
            Exit Sub
        End Try
        tileManager.DownloadTiles(CInt(radian.Text))
    End Sub
    Private Sub tileProvider_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles tileProvider.GotFocus
        AutoScrollPosition = New Point(0, 0)
    End Sub
    Private Sub tileProvider_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tileProvider.SelectedIndexChanged
        tileManager.TileProviders.GotoProvider(tileProvider.SelectedIndex)
        zoom.Items.Clear()
        For i As Integer = tileManager.TileProviders.GetCurrentMinZoom To tileManager.TileProviders.GetCurrentMaxZoom
            zoom.Items.Add(i)
        Next
        If Not zoom.Items.Contains(zoom.Text) Then
            zoom.SelectedIndex = 0
        End If
    End Sub
    Private Sub mnuQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuQuit.Click
        Application.Exit()
    End Sub
    Private Sub DatePicker_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles DatePicker.GotFocus
        AutoScrollPosition = New Point(0, Label2.Top)
    End Sub
End Class
